/*
 * 发送短信配置
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.BsModels;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MsgSmsSetController : BaseController
    {
        public MsgSmsSetController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["BsSqlConnStr"].ToString();
        }

        #region 发送短信配置列表

        /// <summary>
        /// 根据条件查询发送短信配置列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MsgSmsSet data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            string Condition = "";
            Condition += "Name:\"" + data.Name + "\",";
Condition += "UserName:\"" + data.UserName + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询发送短信配置列表

        /// <summary>
        /// 发送短信配置列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MsgSmsSet data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("Name", "2"); //渠道名称
Fields.Add("UserName", "2"); //账号

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("MsgSmsSet", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                
            }
            return Json(obj);
        }

        #endregion

        #region 增加发送短信配置

        /// <summary>
        /// 增加或修改发送短信配置信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加发送短信配置

        /// <summary>
        /// 增加或修改发送短信配置信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MsgSmsSet data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("Name", data.Name); //渠道名称
Fields.Add("UserName", data.UserName); //账号
Fields.Add("AuthPwd", function.MD532(data.AuthPwd)); //密码
Fields.Add("SmsType", data.SmsType); //类别
Fields.Add("ReqUrl", data.ReqUrl); //请求地址
Fields.Add("Params", data.Params); //请求参数

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Add("MsgSmsSet", Fields, 0);
            AddSysLog(data.Id.ToString(), "MsgSmsSet", "add");
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改发送短信配置

        /// <summary>
        /// 增加或修改发送短信配置信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            MsgSmsSet editData = bsdb.MsgSmsSet.FirstOrDefault(m => m.Id == Id) ?? new MsgSmsSet();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改发送短信配置

        /// <summary>
        /// 增加或修改发送短信配置信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MsgSmsSet data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("Name", data.Name); //渠道名称
Fields.Add("UserName", data.UserName); //账号
if (!string.IsNullOrEmpty(data.AuthPwd)) //密码不为空就修改密码，否则不操作
{Fields.Add("AuthPwd", function.MD532(data.AuthPwd)); //密码
}
Fields.Add("SmsType", data.SmsType); //类别
Fields.Add("ReqUrl", data.ReqUrl); //请求地址
Fields.Add("Params", data.Params); //请求参数

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgSmsSet", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"MsgSmsSet","update");
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除发送短信配置信息

        /// <summary>
        /// 删除发送短信配置信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgSmsSet","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgSmsSet", Fields, id);
            }
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgSmsSet","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgSmsSet", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgSmsSet","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgSmsSet", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Sort("MsgSmsSet", Sort, Id);
            
            AddSysLog(Id.ToString(), "MsgSmsSet", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                bsdb.MsgSmsSet.Add(new MsgSmsSet()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                bsdb.SaveChanges();
            }
            AddSysLog("0", "MsgSmsSet", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MsgSmsSet data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Name", "2"); //渠道名称
Fields.Add("UserName", "2"); //账号

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("MsgSmsSet", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MsgSmsSet", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
